//vSAN Bottom

WINKEL=100;
B=224;
L=137;
L1=10;
D=3;
D1=3;
M=2.5;
D2=D+2*4;

CB=280+2.5;
CT=172;
CH=45;
CM=4;

$fn=60;

//translate([1,0,10])
//import("vSAN_Bottom.stl", convexity=3);

module serial_hull()
  {
    // let i be the index of each of our children, but the last one
    for(i=[0:$children-2])
      hull() // we then create a hull between child i and i+1
      {
        children(i); // use child() in older versions of Openscad!
        children(i+1); // this shape is i in the next iteration!
      }
  }

//Note that we can now join any kind of shapes:

//RASPI Winkel

RASP_M=4;

RASP_B=12;
RASP_H=58+M;
RASP_T=12;

module Winkel(){
    difference(){
        union(){
            cube([RASP_B,RASP_T+RASP_M,RASP_H+RASP_M-RASP_B/12]);
            translate([RASP_B/2,0,RASP_H+RASP_M-RASP_B/12])
                rotate([-90,0,0])
                    cylinder(d=RASP_B,h=RASP_M);
        }
        translate([0,RASP_M,RASP_M])
            cube([RASP_B,RASP_T,RASP_H]);
        translate([RASP_B/2,0,9+RASP_M])
            rotate([-90,0,0])
                cylinder(d=3,h=RASP_T);
        translate([RASP_B/2,0,9+RASP_M+ 46.2])
            rotate([-90,0,0])
                cylinder(d=3,h=RASP_T);
    }
}

module Both(){
    union(){
        Winkel();
        translate([70,0,0])
            Winkel();
        hull(){
        cube([1,RASP_T,RASP_M]);
        translate([70,0,0])
            cube([1,RASP_T,RASP_M]);
        }
    }
}

module RASP_Winkel(){
    difference(){
        Both();
        for(x=[RASP_B/2:5:80]){
            translate([x,RASP_T/2,-1])
                cylinder(d=2,h=2*RASP_M,$fn=10);
        }
    }
}
  
  
module Raw(){
    difference(){
        union(){
        serial_hull(){
            cylinder(d=D2,2*M);
            translate([B,0,0])
                cylinder(d=D2,2*M);
            translate([0,L,0])
                cylinder(d=D2,2*M);
            translate([B,L,0])
                cylinder(d=D2,2*M);
            cylinder(d=D2,2*M);
        }
        translate([B/2,L/2,0])
            scale([1.5,1,1])
            cylinder(d=20, 2*M);
        }
    //diff
            cylinder(d=D1,3*M);
            translate([B,0,0])
                cylinder(d=D1,3*M);
            translate([0,L,0])
                cylinder(d=D1,3*M);
            translate([B,L,0])
                cylinder(d=D1,3*M);
    }
}
//Raw();

module HU(){
    difference(){
        union(){
            translate([-CM/2,0,0])
            //difference(){
                cube([CB+2*CM, CT+2*CM, CM+3]);
            //    translate([CM,CM,-CM/2])
            //        cube([CB, CT, CT/2]);
            //}
 
        translate([0,0,0])
            cylinder(r=CM+1/2,h=CH/2);
        translate([CB+CM,0,0])
            cylinder(r=CM+1/2,h=CH/2);
        translate([0,CT+2*CM,0])
            cylinder(r=CM+1/2,h=CH/2);
        translate([CB+CM,CT+2*CM,0])
            cylinder(r=CM+1/2,h=CH/2);
            //NUC
//            serial_hull(){
            cylinder(d=D2,CH/2);
            translate([B,L,0])
                cylinder(d=D2,CH/2);
            translate([0,L,0])
                cylinder(d=D2,CH/2);
            translate([B,0,0])
                cylinder(d=D2,CH/2);
//            translate([B,L,0])
//                cylinder(d=D2,CH/2);
//            }

        }
        //diff
        translate([CM/2,CM,0])
            cylinder(r=1/2,h=CH);
        translate([CM/2+CB,CM,0])
            cylinder(r=1/2,h=CH);
        translate([CM/2,CT+CM,0])
            cylinder(r=1/2,h=CH);
        translate([CM/2+CB,CT+CM,0])
            cylinder(r=1/2,h=CH);
        
        translate([0,0,0])
            cylinder(d=D,h=CH);
        translate([CB+CM,0,0])
            cylinder(d=D,h=CH);
        translate([0,CT+2*CM,0])
            cylinder(d=D,h=CH);
        translate([CB+CM,CT+2*CM,0])
            cylinder(d=D,h=CH);
  
        //NUC
                cylinder(d=D1,3*M);
            translate([B,0,0])
                cylinder(d=D1,3*M);
            translate([0,L,0])
                cylinder(d=D1,3*M);
            translate([B,L,0])
                cylinder(d=D1,3*M);

        translate([-10,-10,2*M])
            cube([2*CB,2*CT,CH]);
            
    }
}

union(){
    mirror(0,1,0)
        HU();
    translate([-235,30,1])
        rotate([0,0,90])
            RASP_Winkel();
}